#!/usr/bin/perl

# Copyright Jose MANS mans@gyptis.frmug.org
# v4 21 Juin 1998

$HOMEBBS        = $ENV{HOMEBBS};

if ( !$INSTALL )
{
   require "$HOMEBBS/frenchy_var.pl";
}

$LIB_FRENCHY	= 1;

require "ctime.pl";
require "lib_filemans.pl";
require "lib_colormans.pl";
require "lib_chrmans.pl";
require "message.txt";	# A vos traductions! Tous les messages y sont!

if (!$MENUP)	{ require "menu.pl"; }
if (!$TAGER)	{ require "tager.pl"; }


$NO_DIR		= 1300;
$NO_MKDIR	= 1301;

$PROTOCOLS	= "$HOMEBBS/sendmodem.ans";


# Qui utilise le programme ?
#
# N_USER = Name User
# L_USER = Level User

if ( !($N_USER = $ENV{'LOGNAME'}) )
{
   $N_USER = $ENV{'USER'}; # Si je m'execute c'est parce que je trouve pas
		# la varibable de LOGNAME du /bin/bash et j'imagine que
		# je suis lance par un shell C (csh ou tcsh)
}

$L_USER = $gcos = (getpwnam($N_USER))[2];


sub config
{
    local($flag);

    $flag = 0;
    $home = $ENV{HOME};
    chdir ("$home/$FRENCHY_REP") || ($flag = $NO_DIR);

    if ($NO_DIR)
    {
       system("mkdir -p $home/$FRENCHY_REP"); # || ($flag == $NO_MKDIR);
       if ( $flag || ($flag == $NO_MKDIR))
       {
          die "Impossible de creer un le repertoire ~/.frenchy";
       }
    }
}

sub pprintf_old
{
    local($var, @ta) = @_;
    local($choix, $ret, $rot);

    $ret = 0;
    if (!$sortie)
    {
       $sortie = STDOUT;
    }
    printf $sortie "%s", $var;
    $vor = $var;
    while ($vor =~ s/\n//) { $ret ++}

    #$ret = split (/\n/, $var, 9999);

    if (!$HTML_tager)
    {
     if ( $ret >= 2)
     {
       $COUNTER = $COUNTER + $ret - 1;
       if ($COUNTER >= $LINE_MAX)
       {
          printf $sortie "$RESET$COLOR_PPRINT";
          printf $sortie "\n-> Tag, Continuer, Stop, Voir le fichier : ";
          chop($choix = <STDIN>);
          #$choix = split (/:/, $choix, 9999);
          $choix =~ tr/a-z/A-Z/;
          printf $sortie "$RESET";
          if ($choix eq "T")
          {
             &tager;
          }
          elsif ($choix eq "C")
          {
          }
          elsif ($choix eq "S")
          {
              &sauve_tager();
          }
          elsif ($choix eq "V")
          {
              &voir;
          }
          $COUNTER = 0;
          pprintf ("\n");
          if (!$HTML_tager)
          {
             color("");
          }
       }
     }
  } # HTML_tager
}


sub     recherche_login
{
        open(PASSWD, "$PASSWDFILE" );

        while ( <PASSWD> )
        {
                s/ //g;
                s/\t//g;
                @tmp = split(/:/, $_, 9999);
                if ( $tmp[0] eq $login )
                {
                        close(PASSWD);
                        return 1;
                }

        }
        close(PASSWD);
        0;
}

sub pcat
{
    local($file_name) = @_;
    local($desc, $save);
    $desc=0;
    open(REP, "$file_name") || ($desc = 1);
    if (!$desc)
    {
       $save = $_;
       while (<REP>)
       {
           pprintf (sprintf"%s", $_);
       }
    }
}

sub cat
{
    local($file, $dest) = @_;

    open (IN, "$file");

    if ($dest)
    {
       open (COUT, ">" . "$dest");
       while(<IN>)
       {
          printf COUT $_;
       }
       close COUT;
    }
    else
    {
       while(<IN>)
       {
          printf $_;
       }
    }
    close IN;
}

sub echo
{
    local($file, $dest) = @_;


    if ($dest)
    {
       open (COUT, ">" . "$dest");
       printf COUT $file;
       close COUT;
    }
    else
    {
       printf $file;
    }
}

sub question
{
     local($vor) = @_;

     chop($vor = <STDIN>);
     $vor =~ tr/a-z/A-Z/;
     return $vor;
}

sub mgetc
{
    local ($key);

    if ($BSD_STYLE) {
        system "stty cbreak </dev/tty >/dev/tty 2>&1";
    }
    else {
        system "stty", '-icanon', 'eol', "\001";
        #system "stty", '-echo', 'eol', "\001";
    }
    $key = getc(STDIN);
    if ($BSD_STYLE) {
        system "stty -cbreak </dev/tty >/dev/tty 2>&1";
    }
    else {
        system "stty", 'icanon', 'eol', '^@'; # ascii null
        #system "stty", 'echo', 'eol', '^@'; # ascii null
    }
    #print "\n";
    return $key;
}

# Mgetc UPPER!
sub mgetcm
{
    local($nono);

    $nono = &mgetc;
    $nono =~ tr/a-z/A-Z/;
    return $nono;
}

# NO Echo
sub mgetce
{
    local ($key);

    if ($BSD_STYLE) {
        system "stty cbreak </dev/tty >/dev/tty 2>&1";
    }
    else {
        system "stty", '-icanon', 'eol', "\001";
        system "stty", '-echo', 'eol', "\001";
    }
    $key = getc(STDIN);
    if ($BSD_STYLE) {
        system "stty -cbreak </dev/tty >/dev/tty 2>&1";
    }
    else {
        system "stty", 'icanon', 'eol', '^@'; # ascii null
        system "stty", 'echo', 'eol', '^@'; # ascii null
    }
    return $key;
}

# No ECHO + convert UPPER
sub mgetcem
{
    local($nono);

    $nono = &mgetce;
    $nono =~ tr/a-z/A-Z/;
    return $nono;
}

sub x_pause
{
    printf" Appuyez sur une touche pour continuer. ";
    if (!$NCURSES)
    {
       &mgetc;
    }
    else
    {}
}

sub ls
{
    local($var) = @_;
    local(@nir);
    $nir = `$LS $var`; 
    @nir = split(' ', $nir, 9999);
    $nir[$NAME] = `$BASENAME $nir[$NAME]`;
    chop($nir[$NAME]);
    return @nir;
}

sub echooff
{
   if ($BSD_STYLE) {
       system "stty cbreak </dev/tty >/dev/tty 2>&1";
   }
   else {
       system "stty", '-icanon', 'eol', "\001";
       system "stty", '-echo', 'eol', "\001";
   }
   open (STDOUT, ">" . "/dev/tty");
}

sub echoon
{
   if ($BSD_STYLE) {
       system "stty -cbreak </dev/tty >/dev/tty 2>&1";
   }
   else {
       system "stty", 'icanon', 'eol', '^@'; # ascii null
       system "stty", 'echo', 'eol', '^@'; # ascii null
   }
   #close STDOUT;
}

sub locate
{
    local($x, $y) = @_;
    printf ("\033[%d;%dH", $y, $x);
}

sub loc
{
    local($x, $y) = @_;
    locate($x, $y);
}

sub cls
{
    printf "$CLS";
}

sub posx_add
{
                  if ($posx == 80)
                  {
                     $posx = 1;
                     $posy ++;
                  }
                  else
                  {
                     $posx ++;
                  }
}

sub posx_sub
{
            if ($posx == 1)
            {
               $posx = 80;
               $posy --;
            }
            else
            {
               $posx --;
            }
}

sub lputs
{
    local($x, $y, $var) = @_;

    locate ($x, $y);

    printf  "%s", $var;
}

sub clean
{
    &echoon;
    exit;
}

sub key_F1
{
    locate(1, 2);
    printf "nb : %s, x_pos: %s ", $nb_ch , $x_pos;
    printf "%s ", &mid($buf, 1, ( $nb_ch - $x_pos)) . &right($buf, $x_pos);
}

sub key_F2
{
    locate (1,3);
    printf "posx: %s", $posx;
}

1;
