#!/bin/perl -w
#
# NewByWeb 1.0 (3/05/1998)
# Loic Breat (c)
# lbreat@mail.dotcom.fr

# includes standarts :-)
use CGI qw(:all);
require ("./config");

##############################################
## Corps du programme                       ##
##############################################

# On affiche l'entete (une bonne chose de faite) 
print header;
print start_html("Verification des informations entrees");

# puis on recupere les parametres dans des variables
$nom		=	param(NOM);
$prenom		=	param(PRENOM);
$sexe		=	param(SEXE);

$ddn_j		=	param(DATENAISS_JOUR);
$ddn_m		=	param(DATENAISS_MOIS);
$ddn_a		=	param(DATENAISS_ANNEE);
$dateNaiss	=	"$ddn_j/$ddn_m/$ddn_a";

$adresse	=	param(ADRESSE);
$codePostal	=	param(CODEPOSTAL);
$ville		=	param(VILLE);
$pays		=	param(PAYS);
$telephone	=	param(TELEPHONE);
$courriel	=	param(MEL);

$connuBbsPar	=	param(CONNUBBSPAR);
$viensIciPour	=	param(POURQUOIVENIRICI);
$loisirs	=	param(LOISIRS);
$unMot		=	param(UNMOT);

$login		=	param(LOGIN);
$password	=	param(PASSWORD);
$verifPass	=	param(VERIFPASS);

$errors=0;

# On appelle les fonctions qui vont tester et afficher
# les parametres passes au script CGI. La plupart des
# parametres ont deja ete testes au niveau du formulaire
# (taille des champs, validite des dates, ...)
# mais mieux vaut les verifier deux fois qu'une!

testNom();
testPrenom();
testSexe();
testDateNaiss();
testAdresse();
testCodePostal();
testVille();
testPays();
testTel();
testEmail();
testConnuBbsPar();
testViensIciPour();
testLoisirs();
testUnMot();
testLogin();
testPasswd();

if ( $errors =~ 0 )
{
	passeAuRobot();
}
else
{
	retourHTML();
}

print end_html;
## ZE END

###########################################
## Fonctions Annexes                     ##
###########################################

sub loginExiste
{
	# Merci a Jose Mans (alias MailBox Polluer)
	# pour cette fonction tres pratique ;-)

	open (PASSWD, $PASSWORDFILE);
	while (<PASSWD>)
	{
		s/ //g;
		s/\t//g;
		@tmp=split(/:/, $_, 9999);

		if ($tmp[0] eq $login)
		{
			close (PASSWD);
			return 1;
		}
			
	}
	close (PASSWD); 
	return 0;

}

sub esddtVide
{
	my ($chaine)=@_;
	if ($chaine eq "")
	{
		return 1;	# VRAI chaine vide
	}

	return 0;	# FAUX chaine non vide		
}

sub printGood
{
	my ($mesg)=@_;	
print <<EOF;
	<font color="#008000"><strong>$mesg</strong></font>
EOF
}

sub printErreur
{
	my ($erreur)=@_;

print <<EOF;
		<font color="#FF0000"><strong>$erreur</strong></font>
EOF
}

################################
## Fonctions de tests         ##
################################

sub testNom
{
	print b("Nom:	$nom");

	# des fois que l'ont ait a faire a un petit rigolo...
	open (BADNAMES, $BADNAMESFILE);
	while ($name = <BADNAMES>)
	{
		chomp ($name);
		if ("\L$nom" eq $name)	# \L: conversion chaine en minsucules
		{
			printErreur("!??!! Tu commences mal! Tu dois entrer ton VRAI nom. Allez, je suis sur que tu vas te ressaisir, n\'est-ce pas ?");
			$errorNom=1;
			$errors++;
		}
	}
	close (BADNAMES);
	
	if (! $errorNom)
	{
		printGood("OK");
	}
	
	print p();
}

sub testPrenom
{
	print b("Prenom:	$prenom");
	open (BADNAMES, $BADNAMESFILE);
	while ($name=<BADNAMES>)
	{
		chomp ($name);
		if ("\L$prenom" eq $name)
		{
			printErreur("!!??!! Rhaaaa ce prenom n'est pas valide du tout! Tu dois entrer ton vrai prenom!");
			$errorPrenom=1;
			$errors++;
		}
	}
	close (BADNAMES);
		
	if (! $errorPrenom)
	{
		printGood("OK");
	}
	print p();
}	

sub testSexe
{
	print b("Sexe:	$sexe");
	if ($sexe eq "FEMME")
	{
		printGood("Enchante de faire votre connaissance madame...");
	}
	elsif ($sexe eq "HOMME")
	{
		printGood("Ravi de faire votre connaissance monsieur...");
	}
	else
	{
		printErreur("Sexe INDETERMINE ???");
	}	
	print p();
}

sub testDateNaiss
{
	print b("Date de naissance:	$dateNaiss");
	printGood ("OK");
	print p();
}


sub testAdresse
{
	print b("Adresse:	$adresse");
	
	print p();
}

sub testCodePostal
{
	print b("Code Postal:	$codePostal");
	printGood ("OK");
	print p();
}

sub testVille
{
	print b("Ville:		$ville");
	printGood ("OK");
	print p();
}

sub testPays
{
	print b("Pays:		$pays");
	printGood ("OK");
	print p();
}

sub testTel
{
	print b("Telephone:	$telephone");
	printGood ("OK");
	print p();
}

sub testEmail
{
	print b("Email:	$courriel");
	printGood("OK");
	print p();
}

sub testConnuBbsPar
{
	print b("Vous avez connu RooT 66 BBS par:	$connuBbsPar");
	printGood("OK");
	print p();
}

sub testViensIciPour
{
	print b("Vous venez ici pour:	$viensIciPour");
	printGood("OK");
	print p();
}

sub testLoisirs
{
	print b("Vos loisirs:	$loisirs");
	printGood("OK");
	print p();
}

sub testUnMot
{
	print b("Un mot au sysop:	$unMot");
	printGood("OK");
	print p();
}

sub testLogin()
{
	print b("Login choisi:	$login");
	open (BADNAMES, $BADNAMESFILE);
	while ($name=<BADNAMES>)	
	{
		chomp ($name);
		if ("\L$login" eq $name)
		{
			printErreur("!!??! Vous ne pouvez pas choisir un login comme celui-ci!");
			$errors++;	
			$errorLogin=1;
		}
	}
	close (BADNAMES);
	
	if (!$errorLogin)
	{
		if ( loginExiste )
		{
			printErreur("Ce login existe deja, choisissez-en un autre");
			$errors++;
		}	
		else
		{
			printGood("Login valide");
		}	
	}

	print p();
}

sub testPasswd
{
	print b("Password...");
	
	if (( $password ne $verifPass) || ($password eq ""))
	{
		printErreur ("Erreur: il y a eu une erreur dans la saisie du mot de passe");
		printErreur ("Vous devez entrer un mot de passe. Verifiez sur la page precedente que les deux mots de passe sont exactement les memes!");
		$errors++;
	}			
	else
	{
		printGood ("OK");
	}
	print p();
}	

sub retourHTML
{
	printErreur("Plusieurs erreurs ont ete commises lors de votre enregistrement");
	printErreur("Utilisez la fonction RETOUR (BACK) de votre navigateur et");
	printErreur("reessayez a nouveau.");
}

sub passeAuRobot
{
		# Redaction du fichier destine au robot
		if (! -e $RESULTFILE)
		{
			open (EXPORT, ">$RESULTFILE") ||print "erreur";
		}
		else
		{
			open (EXPORT, ">>$RESULTFILE") || print "erreur";
		}


		print EXPORT "\n$nom\n$prenom\n$sexe\n$dateNaiss\n$adresse\n$codePostal\n$ville\n$pays\n$telephone\n$courriel\n$connuBbsPar\n$viensIciPour\n$loisirs\n$unMot\n$login\n$password\n$verifPass\n";
		close EXPORT;

		# si erreur dans creation fichier
		if ($? !~ 0 )
		{ 
			$codeErreur = $?;
			print h3 ("ERREUR SYSTEME (#$codeErreur: $!): IMPOSSIBLE DE CREER LE FICHIER DE RESULTATS");
			print h4 ("Envoi d'un email au sysop. Les infos vous concernant lui seront transmises");
			print h4 ("et votre compte sera cree manuellement des que le sysop prendra connaissance");
			print h4 ("de ce probleme.");
			
			open (MAIL, "|mail $EMAILADMIN");
			print MAIL "\nERREUR SYSTEME (#$codeErreur) LORS DE L'AJOUT D'UN UTILISATEUR\n";
			print MAIL "Merci d'ajouter manuellement cet utilisateur:\n";
			print MAIL "  $nom $prenom (l:$login p:$password)\n";
			close MAIL;
		}
		else
		{
			open (MAIL, "|mail $EMAILADMIN");
			print MAIL "Nouvel utilisateur!\n";
			print MAIL "Nom, prenom, sexe: $nom $prenom ($sexe)\n\n";
			print MAIL "Ne le $dateNaiss\n";
			print MAIL "Adresse: $adresse\n";
			print MAIL "CP, Ville, Pays: $codePostal, $ville ($pays)\n\n";
			print MAIL "Tel: $telephone\n";
			print MAIL "Email: $courriel\n";
			print MAIL "Connu BBS par: $connuBbsPar\n";
			print MAIL "Il vient pour: $viensIciPour\n";
			print MAIL "Loisirs: $loisirs\n";
			print MAIL "Un mot pour le sysop:\n$unMot\n\n";
			print MAIL "LOGIN: $login   PASSWORD: $password\n\n";
			print MAIL "Ce compte sera cree dans $DELAI minutes...\n";
			print MAIL "Bonne journee sysop! ;-)\n";
			close MAIL;

			print h3("Les donnees ont ete transmises avec succes:");
			print h4("Votre compte sera automatiquement cree d'ici $DELAI minutes");
		}		
}			











			
